/*
 *   Copyright (c) 2004, Steve Dekorte
 *   All rights reserved. See _BSDLicense.txt.
 */
 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "DBEntry.h"

DBEntry *DBEntry_new(void)
{
  DBEntry *self = calloc(1, sizeof(DBEntry));
  self->key = DBDatum_new();
  self->value = DBDatum_new();
  return self;
}

void DBEntry_free(DBEntry *self)
{
  DBDatum_free(self->key);
  DBDatum_free(self->value);
  free(self);
}

void DBEntry_set(DBEntry *self, unsigned char op, DBT *k, DBT *v)
{
  self->op = op;
  DBDatum_set_(self->key, k);
  if (v) DBDatum_set_(self->value, v);
}

size_t DBEntry_size(DBEntry *self)
{ return self->key->size + self->value->size; }
