/*
 *   Copyright (c) 2004, Steve Dekorte
 *   All rights reserved. See _BSDLicense.txt.
 */
 
#ifndef DBEntry_DEFINED 
#define DBEntry_DEFINED 1

#include "DBDatum.h"

#define DBEntry_PUT    0x1
#define DBEntry_DELETE 0x2

typedef struct DBEntry DBEntry;

struct DBEntry
{
  DBDatum *key;
  DBDatum *value;
  unsigned char op;
};

typedef void (DBEntrySendCallback)(void *, DBEntry *);

DBEntry *DBEntry_new(void);
void DBEntry_free(DBEntry *self);
void DBEntry_set(DBEntry *self, unsigned char op, DBT *k, DBT *v);
void DBEntry_send(DBEntry *self, void *target, DBEntrySendCallback *callback);

size_t DBEntry_size(DBEntry *self);

#endif

