/*
 *   Copyright (c) 2004, Steve Dekorte
 *   All rights reserved. See _BSDLicense.txt.
 */
 
#ifndef DBFILE_DEFINED 
#define DBFILE_DEFINED 1

#include <stdio.h>
#include <db.h>
#include "DBEntry.h"

typedef struct
{
  char *path;
  char *lockPath;
  DB *db;
} DBFile;

DBFile *DBFile_new(void);
void DBFile_free(DBFile *self);

void DBFile_path_(DBFile *self, char *path);
char *DBFile_path(DBFile *self);

void DBFile_open(DBFile *self);
void DBFile_close(DBFile *self);
void DBFile_delete(DBFile *self);

void DBFile_beginTransaction(DBFile *self);
void DBFile_endTransaction(DBFile *self);

void DBFile_put(DBFile *self, DBT *key, DBT *data);
void DBFile_get(DBFile *self, DBT *key, DBT *data);
void DBFile_del(DBFile *self, DBT *key);

void DBFile_performEntry_(DBFile *self, DBEntry *entry);

/* -- lock ------------------------ */

void DBFile_lock(DBFile *self);
void DBFile_unlock(DBFile *self);
unsigned char DBFile_hasLock(DBFile *self);

void DBFile_copyFromPath_(DBFile *self, char *path);

#endif
