/*
 *   Copyright (c) 2004, Steve Dekorte
 *   All rights reserved. See _BSDLicense.txt.
 *
 *   For documentation, see Docs.html
 */

#ifndef TwinDB_DEFINED 
#define TwinDB_DEFINED 1

#include "DBFile.h"
#include "DBEntry.h"
#include "List.h"

typedef struct
{
  char *path;
  DBFile *db1;
  DBFile *db2;
  List *writes;
  size_t writeCacheSize;
  size_t writeCacheSizeLimit; /* if zero, cache size unlimited */
} TwinDB;

TwinDB *TwinDB_new(void);
void TwinDB_free(TwinDB *self);

void TwinDB_path_(TwinDB *self, char *path);

void TwinDB_setWriteCacheSizeLimit_(TwinDB *self, size_t size);

void TwinDB_open(TwinDB *self);
void TwinDB_close(TwinDB *self);
void TwinDB_delete(TwinDB *self);

void TwinDB_sync(TwinDB *self); /* save cached writes */

void TwinDB_put(TwinDB *self, DBT *key, DBT *data);
void TwinDB_get(TwinDB *self, DBT *key, DBT *data);
void TwinDB_del(TwinDB *self, DBT *key);

#endif
  