/*   Copyright (c) 2004, Steve Dekorte
 *   All rights reserved. See _BSDLicense.txt.
 *
 * This is a header that all other source files should include.
 */

/*
 * These defines are helpful for doing OS specific checks in the code
 */
 
#ifndef IOCOMMON_DEFINED
#define IOCOMMON_DEFINED 1

/*#include "IoConfig.h"*/
/*#define LOW_MEMORY_SYSTEM 1*/
#include <stdlib.h>
#include <string.h>

void *cpalloc(void *p, size_t size);

/* Windows stuff */

#if defined(WIN32) || defined(__WINS__) || defined(__MINGW32__) || defined(_MSC_VER)
  #define inline __inline
  
  #if !defined(__MINGW32__)
    /* disable compile warnings which are always treated 
       as errors in my dev settings */

    #pragma warning( disable : 4244 )
    /* warning C4244: 'function' : conversion from 'double ' to 'int ', possible loss of data */
  
    /*#pragma warning( disable : 4090 ) */
    /* warning C4090: 'function' : different 'const' qualifiers  */
  
    /*#pragma warning( disable : 4024 )*/ 
    /* warning C4024: different types for formal and actual parameter  */
  
    /*#pragma warning( disable : 4761 ) */
    /* warning C4761: integral size mismatch in argument; conversion supplied  */
  
    /*#pragma warning( disable : 4047 ) */
    /* warning C4047: '=' : 'char *' differs in levels of indirection from 'int '  */
  #endif

  /* malloc, realloc, free undefined */
  #if !defined(__SYMBIAN32__)
    #include <memory.h> 
  #endif
    
  /* strlen undefined */
  #include <string.h> 
  #include <malloc.h> /* for calloc */
#endif

/*
[DBCS Enabling]

DBCS (Short for Double-Byte Character Set), a character set that uses two-byte (16-bit) characters. Some languages, such as Chinese, Japanese and Korean (CJK), have writing schemes with many different characters that cannot be represented with single-byte codes such as ASCII and EBCDIC. 

In CJK world, CES (Character Encoding Scheme) and CCS (Coded Character Set) are actually different concept(one CES may contain multiple CCS).
For example, EUC-JP is a CES which includes CCS of ASCII and JIS X 0208 (optionally JIS X 0201 Kana and JIS X 0212).

In Japanese (because I am Japanese), 
While EUC-JP and UTF-8 Map ASCII unchanged, ShiftJIS not (However ShiftJIS is de facto standard in Japan). For example, {0x95, 0x5c} represents one character. in ASCII, second byte(0x5c) is back slash character.
*/
/*
check whether double-byte character. supported only ShiftJIS.
if you want to use ShiftJIS characters in string literal, set compiler option -DDBCS_ENABLED=1.
*/
#if DBCS_ENABLED
  #define ismbchar(c)  ISSJIS((unsigned char)c)
  #define mbcharlen(c) 2
  #define ISSJIS(c)    ((c >= 0x81 && c <= 0x9f) || (c >= 0xe0 && c <= 0xfc))
#else
  #define ismbchar(c)   0
  #define mbcharlen(c)  1
#endif  /* DBCS_ENABLED */

#endif

