/*
 *   Copyright (c) 2004, Steve Dekorte
 *   All rights reserved. See _BSDLicense.txt.
 *
 *  TwinDB demo
 *
 */

#include <stdio.h>
#include "TwinDB.h"
#include <string.h>
#include <sys/time.h>     
#define N 100000

double mtime(void)
{
  double v;
  struct timeval tp;
  struct timezone tz;
  gettimeofday(&tp, &tz);
  v = tp.tv_sec;
  v += ((double)tp.tv_usec)/1000000.0;
  return v;
}

void test(void)
{
    double t1 = mtime();
    
    TwinDB *t = TwinDB_new();
    TwinDB_path_(t, "test");
    TwinDB_open(t);
    
    {
      int i;
      char s[100];
      
      for (i = 0; i < N; i++)
      {
        DBT k;
        sprintf(s, "%i", i);
	if (i % (N/10) == 0) printf("put %i\n", i);
	k.data = s;
	k.size = strlen(s);
        TwinDB_put(t, &k, &k);
      TwinDB_sync(t);

      }
      TwinDB_sync(t);
      
      {
      float d = mtime() - t1;
      printf("%i writes in %f secs\n", N, d);
      printf("%i writes/sec\n", (int)(N/d));
      t1 = mtime();
      }
      
      for (i = 0; i < N; i++)
      {
        DBT k, d;
        sprintf(s, "%i", i);
	k.data = s;
	k.size = strlen(s);
        TwinDB_get(t, &k, &d);
	if (i % (N/10) == 0) 
	{
	  printf("get %i = %s\n", i, (char *)d.data);
	}
      }    
    
      {
      float d = mtime() - t1;
      printf("%i reads in %f secs\n", N, d);
      printf("%i reads/sec\n", (int)(N/d));
      t1 = time(NULL);
      }
    }
    
    TwinDB_free(t);
}

int main(int argc, const char * argv[]) 
{
  int i;
  for (i=0; i<1; i++)
  {
    test();
  }
  return 0;
}

